import tensorflow as tf


def model_step1_cnn(images):
    variables = []
    w_conv = tf.Variable(tf.truncated_normal([4,4,1,32], stddev=0.1), name="stg1_w_conv")
    b_conv = tf.Variable(tf.truncated_normal([12, 12, 1], stddev=0.1), name="stg1_b_conv")
    conv = tf.nn.conv2d(images, w_conv, strides=[1, 1, 1, 1], padding='SAME')
    conv_a = tf.nn.leaky_relu(conv + b_conv)

    mp = tf.nn.max_pool(conv_a, ksize=[1, 3, 3, 1], strides=[1, 2, 2, 1], padding='SAME')
    print("mp ", mp.shape)

    w_flat = tf.Variable(tf.truncated_normal([6 * 6 * 32, 16], stddev=0.1), name="stg1_w_flat")
    b_flat = tf.Variable(tf.truncated_normal([16], stddev=0.1), name="stg1_b_flat")
    flat = tf.reshape(mp, [-1, 6 * 6 * 32])
    flat_a = tf.nn.leaky_relu(tf.matmul(flat, w_flat) + b_flat)

    w_flat2 = tf.Variable(tf.truncated_normal([16, 2], stddev=0.1), name="stg1_w_flat2")
    b_flat2 = tf.Variable(tf.truncated_normal([2], stddev=0.1), name="stg1_b_flat2")
    flat2_a = tf.nn.sigmoid(tf.matmul(flat_a, w_flat2)+b_flat2)

    variables.append(w_conv)
    variables.append(w_flat)
    variables.append(w_flat2)

    variables.append(b_conv)
    variables.append(b_flat)
    variables.append(b_flat2)

    return flat2_a, flat_a, variables


def model_step2_cnn(images, hidden_from_stage_1):
    variables = []
    w_conv = tf.Variable(tf.truncated_normal([5,5,1,64], stddev=0.1), name="stg2_w_conv")
    b_conv = tf.Variable(tf.truncated_normal([24, 24, 1], stddev=0.1), name="stg2_b_conv")
    conv = tf.nn.conv2d(images, w_conv, strides=[1, 1, 1, 1], padding='SAME')
    conv_a = tf.nn.leaky_relu(conv + b_conv)

    mp = tf.nn.max_pool(conv_a, ksize=[1, 3, 3, 1], strides=[1, 2, 2, 1], padding='SAME')
    print("mp ", mp.shape)

    w_conv2 = tf.Variable(tf.truncated_normal([5, 5, 64, 128], stddev=0.1), name="stg2_w_conv2")
    b_conv2 = tf.Variable(tf.truncated_normal([12, 12, 1], stddev=0.1), name="stg2_b_conv2")
    conv2 = tf.nn.conv2d(mp, w_conv2, strides=[1, 1, 1, 1], padding='SAME')
    conv2_a = tf.nn.leaky_relu(conv2 + b_conv2)

    mp2 = tf.nn.max_pool(conv2_a, ksize=[1, 3, 3, 1], strides=[1, 2, 2, 1], padding='SAME')
    print("mp ", mp2.shape)

    w_flat = tf.Variable(tf.truncated_normal([6 * 6 * 128 + 16, 256], stddev=0.1), name="stg2_w_flat")
    b_flat = tf.Variable(tf.truncated_normal([256], stddev=0.1), name="stg2_b_flat")
    flat = tf.reshape(mp2, [-1, 6 * 6 * 128])
    flat = tf.concat([flat, hidden_from_stage_1], 1)
    flat_a = tf.nn.leaky_relu(tf.matmul(flat, w_flat) + b_flat)

    w_flat2 = tf.Variable(tf.truncated_normal([256, 2], stddev=0.1), name="stg2_w_flat2")
    b_flat2 = tf.Variable(tf.truncated_normal([2], stddev=0.1) , name="stg2_b_flat2")
    flat2_a = tf.nn.sigmoid(tf.matmul(flat_a, w_flat2)+b_flat2)

    variables.append(w_conv)
    variables.append(w_conv2)
    variables.append(w_flat)
    variables.append(w_flat2)

    variables.append(b_conv)
    variables.append(b_conv2)
    variables.append(b_flat)
    variables.append(b_flat2)

    return flat2_a, variables